"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.escape = void 0;
/**
 * This module provides utility functions for working with RegExp in TypeScript.
 *
 * @since 2.0.0
 */
/**
 * Escapes special characters in a regular expression pattern.
 *
 * @example
 * import * as RegExp from "effect/RegExp"
 *
 * assert.deepStrictEqual(RegExp.escape("a*b"), "a\\*b")
 *
 * @since 2.0.0
 */
const escape = string => string.replace(/[/\\^$*+?.()|[\]{}]/g, "\\$&");
exports.escape = escape;
//# sourceMappingURL=RegExp.js.map